#include "state_data.h"
 
void Xport_report_suite::load_state_data(const std::string& file_path, std::vector<state_info>& siv)
{
  std::ifstream file(file_path.c_str());
  if (file) {
    std::string line;
    // first line is headers
    std::getline(file, line);

    while (std::getline(file, line)) {
      extract_data(line, siv);
    }

  }
}


void Xport_report_suite::extract_data(const std::string& line, std::vector<state_info>& siv)
{
  std::string::const_iterator beg = line.begin(), end = std::find(line.begin(), line.end(), '\t');
  std::string name(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string abbr(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string capital(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string largest_city(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string nickname(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string slogan(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string tree(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string flower(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream population_str(std::string(beg, end));
  int population;
  population_str >> population;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream population_rank_str(std::string(beg, end));
  int population_rank;
  population_rank_str >> population_rank;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream area_str(std::string(beg, end));
  long area;
  area_str >> area;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream area_rank_str(std::string(beg, end));
  int area_rank;
  area_rank_str >> area_rank;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream desity_str(std::string(beg, end));
  double density;
  desity_str >> density;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream density_rank_str(std::string(beg, end));
  int density_rank;
  density_rank_str >> density_rank;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream pct_water_str(std::string(beg, end));
  double pct_water;
  pct_water_str >> pct_water;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string admit_date(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::string web_site(beg, end);

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream region_str(std::string(beg, end));
  int region;
  region_str >> region;

  beg = end + 1;
  end = std::find(beg, line.end(), '\t');
  std::istringstream division_str(std::string(beg, end));
  int division;
  division_str >> division;

  state_info si(name, abbr, capital, largest_city, nickname, slogan, tree, flower, population, population_rank,
    area, area_rank, density, density_rank, pct_water, admit_date, web_site, region, division);

  siv.push_back(si);
}

